#####################################
#
#  Trailer.pm
#  Author:  R.N.F.Vossen
#  Licence: GNU
#

my $version ='$Id: Trailer.pm 8058 2005-07-07 13:06:53Z guus $';

our $VERSION = "1.0";

package Trailer;

my $undef='* undef *';

sub new
{
    $package=shift;
    my($data)=shift;
    my($self)={};

    $self->{'awake'}=1;
    $self->{'count'}=1;
    $self->{'title'}='default title';
    $self->{'showlimit'}=100;
    $self->{'showlevel'}=0;
    $self->{'leader'}="\n";
    $self->{'page'}="
<html>
 <header>
  <title><:>title<:></title>
 </header>
 <body>
  <b>Time: <:>time<:></b><br>
  <hr>
  <:>index<:>
  <hr>
<b># <:>counter<:></b><br>
  <:>datalist<:>
 </body>
</html>
";

    bless $self,$package;
    $self->populate($data);
    return($self);
}

sub awake
{
  my $self=shift;

  my $future=shift;
  my $past=$self->{'awake'};

  $self->{'awake'}=$future if (defined($future));

  return($past);
}

sub populate
{
    my($self)=shift;
    my($data)=shift;

    foreach $key (keys %$data)
    {
	$self->{$key}=$data->{$key};
    }
}

sub showarray
{
    my ($self)=shift;
    my (@vals)=@_;
    my (@types)=();
    my ($type)='';
    my ($analysis)='';
    my ($versie)='';
    my ($i)=0;
    my ($level)=$self->{'showlevel'};

    foreach $elt (@vals)
    {
      push(@types, defined ($elt)?$elt:$undef);

    }

    $analysis.="<ul>";

    for ($i=0;$i<@types;$i++)
    {
        $self->{'showlevel'}++ if ($types[$i]=~/(HASH|ARRAY)\(/);
        if ($types[$i]=~/ARRAY\(/ )
        {
            $type=$types[$i];
	    if (exists $self->{'recurrent'}->{$type})
            {
	        $types[$i]=~s/\(.+//;
		$analysis.="<li> [$i] ".$types[$i].'(#'.$self->{'recurrent'}->{$type}.')';
            }
            else
            {
	        $types[$i]=~s/\(.+//;
                $self->{'recurrent'}->{$type}=$self->{'count'}++;
	        $analysis.="<li> [$i] ".'('.$self->{'recurrent'}->{$type}.')'.$types[$i];
	        $analysis.=$self->showarray(@{$vals[$i]}) unless ($self->{'showlevel'}>$self->{'showlimit'});
            }
        }
        elsif ($types[$i]=~/HASH\(/)
        {
            $type=$types[$i];
	    if (exists $self->{'recurrent'}->{$type})
            {
	        $types[$i]=~s/\(.+//;
		$analysis.="<li> [$i] ".$types[$i].'(#'.$self->{'recurrent'}->{$type}.')';
            }
            else
            {
	        $types[$i]=~s/\(.+//;
                $self->{'recurrent'}->{$type}=$self->{'count'}++;
	        $analysis.="<li> [$i] ".'('.$self->{'recurrent'}->{$type}.')'.$types[$i];
	        $analysis.=$self->showhash(%{$vals[$i]}) unless ($self->{'showlevel'}>$self->{'showlimit'});
            }
        }
        else
        {
	    $types[$i]=~s/</&lt;/g;
	    $types[$i]=~s/\n/<br>/gs;
	    $analysis.="<li> [$i]".$types[$i];
        }
        $self->{'showlevel'}=$level;
    }
    $analysis.="</ul>";
    return($analysis);
}

sub showhash
{
    my ($self)=shift;
    my (%vals)=@_;
    my (@types)=();
    my ($type)='';
    my ($analysis)='';
    my ($versie)='';
    my ($i)=0;
    my ($level)=$self->{'showlevel'};
    my (@vals);

    foreach $key (sort keys %vals)
    {
	push(@vals,$key,$vals{$key});
    }

    foreach $elt (@vals)
    {
      push(@types, defined ($elt)?$elt:$undef);
    }

    $analysis.="<ul>";
    for ($i=1;$i<@types;$i+=2)
    {
	$self->{'showlevel'}++ if ($types[$i]=~/(HASH|ARRAY)\(/);
	if ($types[$i]=~/ARRAY\(/)
	{
            $type=$types[$i];
	    if (exists $self->{'recurrent'}->{$type})
            {
	        $types[$i]=~s/\(.+//;
	        $analysis.="<li>{'".$vals[$i-1]."'}->".$types[$i].'(#'.$self->{'recurrent'}->{$type}.')';
            }
            else
            {
	        $types[$i]=~s/\(.+//;
                $self->{'recurrent'}->{$type}=$self->{'count'}++;

                $analysis.="<li>{'".$vals[$i-1]."'}->".'('.$self->{'recurrent'}->{$type}.')'.$types[$i];
	        $analysis.=$self->showarray(@{$vals[$i]}) unless ($self->{'showlevel'}>$self->{'showlimit'});
            }

	}
	elsif ($types[$i]=~/HASH\(/)
	{
            $type=$types[$i];
	    if (exists $self->{'recurrent'}->{$type})
            {
	        $types[$i]=~s/\(.+//;
	        $analysis.="<li>{'".$vals[$i-1]."'}->".$types[$i].'(#'.$self->{'recurrent'}->{$type}.')';
            }
            else
            {
	        $types[$i]=~s/\(.+//;
                $self->{'recurrent'}->{$type}=$self->{'count'}++;

                $analysis.="<li>{'".$vals[$i-1]."'}->".'('.$self->{'recurrent'}->{$type}.')'.$types[$i];
	        $analysis.=$self->showhash(%{$vals[$i]}) unless ($self->{'showlevel'}>$self->{'showlimit'});
            }
	}
	else
	{
	    $types[$i]=~s/</&lt;/g;
	    $types[$i]=~s/\n/<br>/gs;
	    $analysis.="<li>{'".$vals[$i-1]."'}->".$types[$i];
	}
	$self->{'showlevel'}=$level;
    }
   $analysis.="</ul>";
   return($analysis);
}

sub showstack
{
    my ($self)=shift;
    my ($package,$file,$line,$subname,$stackinfo,);

    my ($indent)=0;
    while (caller($indent++)) {}

    $stackinfo ="_" x ($indent-4);
    $stackinfo.=$package."->".$subname."--->" if (($package,$file,$line,$subname)=caller(2));
    $stackinfo.=$package."->".$subname."  line = $line"  if (($package,$file,$line,$subname)=caller(1));

    return($stackinfo);
}

sub analyze
{
    my ($self)=shift;
    if ($self->{'awake'})
    {
      push(@{$self->{'book'}},{'array' => $self->showarray(@_), 'stack' => $self->showstack()});
      $self->{'recurrent'}={};
    }
}

sub analyse
{
    my ($self)=shift;
    if ($self->{'awake'})
    {
      push(@{$self->{'book'}},{'array' => $self->showarray(@_), 'stack' => $self->showstack()});
      $self->{'recurrent'}={};
    }
}

sub print
{
    my($self)=shift;
    my($cnt)=0;

    return unless ($self->{'awake'});

    $self->{'time'}=localtime();

    open (o1, ">$self->{'dir'}/index.html") || warn "\nTrailer alert:\nfile $self->{'dir'}/index.html failed to open: $!\n\n";

    print o1 '<html><head><title>',$self->{'title'},'</title></head><body>';
    print o1 '<b>Time: ',$self->{'time'},'</b><br><hr>';

    for ($cnt=0;$cnt<@{$self->{'book'}};)
    {
        my($page)=$self->{'page'};

        $self->{'counter'}=$cnt+1;
        $self->{'datalist'}=$self->{'book'}->[$cnt]->{'array'};

        $self->{'index'}="<a href=\"index.html\">Index</a><br>";
	$self->{'index'}.="<br>".&hrefy($cnt-2,$self->{'book'}->[$cnt-2]->{'stack'}) if ($cnt>1);
        $self->{'index'}.="<br>".&hrefy($cnt-1,$self->{'book'}->[$cnt-1]->{'stack'}) if ($cnt>0);

        $self->{'index'}.="<br>".&hrefy($cnt,$self->{'book'}->[$cnt]->{'stack'});
	print o1 "<br>".&hrefy($cnt,$self->{'book'}->[$cnt]->{'stack'})."\n";

        $self->{'index'}.="<br>".&hrefy($cnt+1,$self->{'book'}->[$cnt+1]->{'stack'}) if ($cnt+1<@{$self->{'book'}});
	$self->{'index'}.="<br>".&hrefy($cnt+2,$self->{'book'}->[$cnt+2]->{'stack'}) if ($cnt+2<@{$self->{'book'}});

	$cnt++;

	open (o2, ">$self->{'dir'}/Trailer$cnt.html") || warn "\nTrailer alert:\nfile $self->{'dir'}/$cnt.html failed to open: $!\n\n";
        $page=~s/<:>([^<]+)<:>/$self->{$1}/g;
        print o2 $page;

	close(o2);
    }

    print o1 '</body></html>';

    close(o1);
}

sub hrefy
{
    my($cnt)=shift;
    my($stacktrace)=shift;
    $cnt++;

    my($href)="<a href=\"Trailer$cnt.html\"><b>$cnt</b> $stacktrace</a>\n";

    return($href);
}


sub usage
{
  print '

Minimal requirements

   $object = new Trailer();
   $object->analyse("any list of: constant, scalar, array, hash, or reference to array or hash");
   $object->print();

For each call to the analyse function an html text will be generated that contains a overview of the content of each datum to a depth of 100 levels.

At the call of the print function this html texts will be printed to file in the current directory.
These files are named: index.html Trailer1.html, Trailer2.html, ... etc.

To specify a different directory use:
   $object = new Trailer({\'dir\' => \'directory specification\'});

To specify a different depth of analysis use:
   $object = new Trailer({\'showlimit\' => \'a number\'});

To specify a nice title for your html texts  use:
   $object = new Trailer({\'title\' => \'what a piece of work is man\'});

To do both use:
   $object = new Trailer(
                         {
                          \'dir\' => \'directory specification\',
                          \'showlimit\' => \'a number\'
                         }
                        );
';
}

sub asciify
{
  my $self=shift;

  if ($self->{'awake'})
  {
    print $self->{'leader'},'['.localtime()."]\n";
    print $self->ascarray(@_);
    $self->{'recurrent'}={};
  }
}


sub adjust
{
  my $self=shift;
  my $elt=shift;

  return $undef if (!defined($elt));
  return 'SELF' if ($self eq $elt);
  return $elt;
}

sub ascarray
{
    my ($self)=shift;
    my (@vals)=@_;
    my (@types)=();
    my ($type)='';
    my ($analysis)='';
    my ($versie)='';
    my ($i)=0;
    my ($level)=$self->{'showlevel'};

    foreach $elt (@vals)
    {
      push(@types,$self->adjust($elt));
    }

    for ($i=0;$i<@types;$i++)
    {
        $self->{'showlevel'}++ if ($types[$i]=~/(HASH|ARRAY)\(/);
        if ($types[$i]=~/ARRAY\(/)
        {
            $type=$types[$i];
	    if (exists $self->{'recurrent'}->{$type})
            {
	        $types[$i]=~s/\(.+//;
		$analysis.=(' ' x (3*$level))."[$i] ".$types[$i].'(#'.$self->{'recurrent'}->{$type}.")\n";
            }
            else
            {
	        $types[$i]=~s/\(.+//;
                $self->{'recurrent'}->{$type}=$self->{'count'}++;
	        $analysis.=(' ' x (3*$level))."[$i] ".'('.$self->{'recurrent'}->{$type}.')'.$types[$i]."\n";
	        $analysis.=$self->ascarray(@{$vals[$i]}) unless ($self->{'showlevel'}>$self->{'showlimit'});
            }
        }
        elsif ($types[$i]=~/HASH\(/)
        {
            $type=$types[$i];
	    if (exists $self->{'recurrent'}->{$type})
            {
	        $types[$i]=~s/\(.+//;
		$analysis.=(' ' x (3*$level))."[$i] ".$types[$i].'(#'.$self->{'recurrent'}->{$type}.")\n";
            }
            else
            {
	        $types[$i]=~s/\(.+//;
                $self->{'recurrent'}->{$type}=$self->{'count'}++;
	        $analysis.=(' ' x (3*$level))."[$i] ".'('.$self->{'recurrent'}->{$type}.')'.$types[$i]."\n";
	        $analysis.=$self->aschash(%{$vals[$i]}) unless ($self->{'showlevel'}>$self->{'showlimit'});
            }
        }
        else
        {
	    $analysis.=(' ' x (3*$level))."[$i]".$types[$i]."\n";
        }
        $self->{'showlevel'}=$level;
    }
    return($analysis);
}

sub aschash
{
    my ($self)=shift;
    my (%vals)=@_;
    my (@types)=();
    my ($type)='';
    my ($analysis)='';
    my ($versie)='';
    my ($i)=0;
    my ($level)=$self->{'showlevel'};
    my (@vals);

    foreach $key (sort keys %vals)
    {
	push(@vals,$key,$vals{$key});
    }

    foreach $elt (@vals)
    {
      push(@types,$self->adjust($elt));
    }

    for ($i=1;$i<@types;$i+=2)
    {
	$self->{'showlevel'}++ if ($types[$i]=~/(HASH|ARRAY)\(/);
	if ($types[$i]=~/ARRAY\(/)
	{
            $type=$types[$i];
	    if (exists $self->{'recurrent'}->{$type})
            {
	        $types[$i]=~s/\(.+//;
	        $analysis.=(' ' x (3*$level))."{'".$vals[$i-1]."'}->".$types[$i].'(#'.$self->{'recurrent'}->{$type}.")\n";
            }
            else
            {
	        $types[$i]=~s/\(.+//;
                $self->{'recurrent'}->{$type}=$self->{'count'}++;

                $analysis.=(' ' x (3*$level))."{'".$vals[$i-1]."'}->".'('.$self->{'recurrent'}->{$type}.')'.$types[$i]."\n";
	        $analysis.=$self->ascarray(@{$vals[$i]}) unless ($self->{'showlevel'}>$self->{'showlimit'});
            }
	}
	elsif ($types[$i]=~/HASH\(/)
	{
            $type=$types[$i];
	    if (exists $self->{'recurrent'}->{$type})
            {
	        $types[$i]=~s/\(.+//;
	        $analysis.=(' ' x (3*$level))."{'".$vals[$i-1]."'}->".$types[$i].'(#'.$self->{'recurrent'}->{$type}."\n";
            }
            else
            {
	        $types[$i]=~s/\(.+//;
                $self->{'recurrent'}->{$type}=$self->{'count'}++;

                $analysis.=(' ' x (3*$level))."{'".$vals[$i-1]."'}->".'('.$self->{'recurrent'}->{$type}.')'.$types[$i]."\n";
	        $analysis.=$self->aschash(%{$vals[$i]})."\n" unless ($self->{'showlevel'}>$self->{'showlimit'});
            }
	}
	else
	{
	    $analysis.=(' ' x (3*$level))."{'".$vals[$i-1]."'}->".$types[$i]."\n";
	}
	$self->{'showlevel'}=$level;
    }
   return($analysis);
}

'end Trailer';

=head1 Trailer.pm

=head1 SYNOPSIS

   $object = new Trailer();
   $object->analyse("any list of: constant, scalar, array, hash, or reference to array or hash");
   $object->print();

   For each call to the analyse function an html text will be generated that contains 
   an overview of the content of each datum to a depth of 100 levels.

   At the call of the print function this html texts will be printed to file in the current directory.
   These files are named: index.html Trailer1.html, Trailer2.html, ... etc.

   To specify a different directory use:
   $object = new Trailer({'dir' => 'directory specification'});

   To specify a different depth of analysis use:
   $object = new Trailer({'showlimit' => 'a number'});

   To specify a nice title for your html texts  use:
   $object = new Trailer({'title' => 'what a piece of work is man'});

   One can combine ad lib:
   $object = new Trailer(
                         {
                          'dir'       => 'directory specification',
                          'showlimit' => 'a number'
                         }
                        );

=head1 DEPENDENCIES

none

=head1 DESCRIPTION

Trailer presents the content of a PERL variable in a readable form
by transforming it to either an ASCII text or an HTML text

=head1 METHODS

=head2 analyze(), analyse()

=over

    Parameters;

    Any list of PERL variables no matter how complicated, that does not contain any reference to a glob, filehandle or codeblock

    Result:

    The object stores in itself an HTML text showing structure and content of said list of PERL variables

=back

=head2 ascarray()

=over

    Parameters

    Any list of PERL variables no matter how complicated, that does not contain any reference to a glob, filehandle or codeblock

    Result:

    a text showing structure and content of said list of PERL variables

=back

=head2 asciify()

=over

    Parameters;

    Any list of PERL variables no matter how complicated, that does not contain any reference to a glob, filehandle or codeblock

    Result:
  
    An ASCII text showing structure and content of said list of PERL variables is printed to standard out

=back

=head2 awake()

=over

    Parameters;

    0 or 1;

    Result:

    0 disables the analyse() and analyze() function
    1 enables the analyse() and analyze() function

=back

=head2 print()

=over

    Parameters;

    none

    Result:

    Each and every HTML text produced as a result of analyze() or analyse() is printed to an HTML file
    named trailer 

=back

=head1 BUGS

    No known bugs

=head1 AUTHOR

    R.N.F.Vossen     

=head1 COPYRIGHT AND LICENCE

Copyright (C) 2004 by Tilburg University 

    This library is free software; you can redistribute it and/or modify
    it under the same terms as Perl itself, either Perl version 5.8.4 or,
    at your option, any later version of Perl 5 you may have available.

=cut




